#!/bin/sh


WORKDIR=/root
case "$LANG" in
	fr_FR)
		echo "-----------------------"
		echo "Configuration de SSH..."
		echo "-----------------------"
		echo -n "Voulez vous crer une paire de cl publique/priv pour 'root' ? (o/n) [n] "
	;;
	*)
		echo "------------------"
		echo "Configuring SSH..."
		echo "------------------"
		echo -n "Do you want to generate a public/private keypair for user 'root' ? (y/n) [n] "
	;;
esac
read sshkeys
if [ "$sshkeys" = "o" -o "$sshkeys" = "y" ]; then
	passok=1
	while [ "$passok" != "0" ] ; do
		ssh-keygen -t rsa -f ${WORKDIR}/key.ppk 2>${WORKDIR}/err
		passok=$(grep -c "passphrase too short" < ${WORKDIR}/err)
		if [ "$passok" = "1" ]; then
			echo "passphrase too short: have 4 bytes, need > 4"
			echo
		fi
	done
	cat ${WORKDIR}/key.ppk.pub > /root/.ssh/authorized_keys
	cat ${WORKDIR}/key.ppk >> /root/.ssh/authorized_keys
	case "$LANG" in
		fr_FR) echo "Dsactivation de l'authentification SSH  l'aide de mots de passe standards" ;;
		*) echo "Disabling SSH authentification SSH with standards passwords" ;;
	esac
	config setprop sshd PasswordAuthentication no
	signal-event remoteaccess-update
	case "$LANG" in
		fr_FR) echo "Envoi de la cl prive par mail  l'admin..." ;;
		*) echo "Sending private key by e-mail to the admin..." ;;
	esac
	echo > ${WORKDIR}/ssh.txt
	echo >> ${WORKDIR}/ssh.txt
	echo >> ${WORKDIR}/ssh.txt
	case "$LANG" in
		fr_FR)
			echo "- L'accs SSH  votre serveur SME a t scuris avec une paire de cls publique-priv." >> ${WORKDIR}/ssh.txt
			echo "- L'authenfication par SSH  l'aide de mots de passe standards a t dsactive pour augmenter le niveau de scurit." >> ${WORKDIR}/ssh.txt
			echo >> ${WORKDIR}/ssh.txt
			echo "- Les cls ont ts gnrs avec OPENSSH et si vous utilisez PuTTY et WinSCP, vous devrez alors modifier" >> ${WORKDIR}/ssh.txt
			echo "- la cl publique qui vous a t envoye dans ce mail avant de pouvoir l'utiliser avec WinSCP par exemple." >> ${WORKDIR}/ssh.txt
			echo "- Il suffit d'diter la cl avec PuTTYGen et de la sauvegarder dans le bon format." >> ${WORKDIR}/ssh.txt
			echo "- Vous pourrez ensuite utiliser la cl avec WinSCP..." >> ${WORKDIR}/ssh.txt
			echo >> ${WORKDIR}/ssh.txt
			echo "- ATTENTION : Ne perdez pas le fichier joint  ce mail, il a t supprim du serveur !" >> ${WORKDIR}/ssh.txt
			echo "- Si vous perdez ce fichier, vous devrez ractiver l'authentification par SSH  l'aide de mots de passe" >> ${WORKDIR}/ssh.txt
			echo "- standards dans le server-manager pour supprimer et recrer le fichier '${WORKDIR}/.ssh/authorized_keys'" >> ${WORKDIR}/ssh.txt
			mutt -s "Mise en place des cls SSH" admin < ${WORKDIR}/ssh.txt -a ${WORKDIR}/key.ppk
		;;
		*)
			echo "- SSH access to your server has been secured with a public-private key pair." >> ${WORKDIR}/ssh.txt
			echo "- SSH authenfication with standards passwords has been disabled to increase security level." >> ${WORKDIR}/ssh.txt
			echo >> ${WORKDIR}/ssh.txt
			echo "- Keys have been generated using OPENSSH and if you're using PuTTY and WinSCP, you should then modify" >> ${WORKDIR}/ssh.txt
			echo "- the public key that was attached to this e-mail before being able to use it with WinSCP for exemple." >> ${WORKDIR}/ssh.txt
			echo "- You just have to edit the key with PuTTYGen and saving it in the good format." >> ${WORKDIR}/ssh.txt
			echo "- You will then be able to use the key with WinSCP..." >> ${WORKDIR}/ssh.txt
			echo >> ${WORKDIR}/ssh.txt
			echo "- BE CAREFUL : Don't lose this attached file as it has been deleted from the server!" >> ${WORKDIR}/ssh.txt
			echo "- If you lose this file, you will have to reactivate SSH authentification with standards passwords" >> ${WORKDIR}/ssh.txt
			echo "- in the server-manager to delete and recreate the file '${WORKDIR}/.ssh/authorized_keys'" >> ${WORKDIR}/ssh.txt
			mutt -s "SSH keys installation report" admin < ${WORKDIR}/ssh.txt -a ${WORKDIR}/key.ppk
		;;
	esac
	rm -f ${WORKDIR}/err
	rm -f ${WORKDIR}/key.ppk.pub
	rm -f ${WORKDIR}/key.ppk
	rm -f ${WORKDIR}/ssh.txt
	echo
	echo
	echo
fi
